use std::io::{self, BufRead};

use anagrams::{AnagramDict, Dict};

fn main() {
    println!("[ Loading dictionnary from file ]");
    let dict = Dict::load().unwrap();
    println!("[ Precomputing the hashmap ]");
    let dict: AnagramDict = (&dict).into();
    println!("[ Ready ]");
    let stdin = io::stdin();
    for line in stdin.lock().lines() {
        let line = line.unwrap();
        if line == "!" {
            break;
        }
        //let freq = FrequencyHash::compute(&line);
        //println!("{freq:?}");
        if let Some(words) = dict.find(&line) {
            println!("Found anagrams:");
            for word in words {
                println!("> {word}");
            }
        } else {
            println!("No anagram found");
        }
    }
}
